﻿#region Using directives

using System;
using System.Collections.Generic;

#endregion

namespace STL.Generic
{
    public static class Algorithm
    {
        public static IForwardIterator<T> Copy<T>
            (IForwardIterator<T> first, IForwardIterator<T> last, IForwardIterator<T> x)
        {
            while (!first.Equals(last))
            {
                x.Value = first.Value;
                x.Next();
                first.Next();
            }
            return (IForwardIterator<T>)x.Clone();
        }

        public static Action<T> ForEach<T>
            (IForwardIterator<T> first, IForwardIterator<T> last, Action<T> f)
        {
            while (!first.Equals(last))
            {
                f(first.Value);
                first.Next();
            }
            return f;
        }

        public static void Fill<T>
            (IForwardIterator<T> first, IForwardIterator<T> last, T x)
        {
            while (!first.Equals(last))
            {
                first.Value = x;
                first.Next();
            }
        }

        public static void Generate<T>
            (IForwardIterator<T> first, IForwardIterator<T> last, NullaryFunction<T> g)
        {
            while (!first.Equals(last))
            {
                first.Value = g();
                first.Next();
            }
        }

    }
}
